/*
 *  Copyright (C) 2011 Jesus Navalon i Pastor <jnavalon at redhermes dot net>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * dg_Password.java
 *
 * Created on 05/06/2011, 02:15:13
 */
package kuasar.plugin.utils.dialogs;

import java.awt.Color;
import java.awt.event.KeyEvent;
import javax.swing.JFileChooser;
import kuasar.plugin.Intercom.GUI;
import kuasar.plugin.utils.Connection;

/**
 *
 * @author Jesus Navalon i Pastor <jnavalon at redhermes dot net>
 */
public class dg_KeyStore extends javax.swing.JDialog {
    private String keystore=null;
    private String address = null;

    public dg_KeyStore(java.awt.Frame parent, boolean modal, String address) {
        super(parent, modal);
        this.address = address;
        initComponents();
        this.getContentPane().setBackground(Color.black);
        this.getRootPane().setOpaque(false);
        lbl_error.setVisible(false);
        if(address == null){
            tb_saveKey.setSelected(false);
            tb_saveKey.setEnabled(false);
            tb_save.setSelected(false);
            tb_save.setEnabled(false);
        }
        if(parent == null){
            setLocation(GUI.getFrameLocation().x + this.getPreferredSize().width/2, 
                    GUI.getFrameLocation().y + this.getPreferredSize().height/2);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pn_Buttons = new javax.swing.JPanel();
        tgb_top = new javax.swing.JToggleButton();
        bt_Cancel = new javax.swing.JButton();
        bt_Accept = new javax.swing.JButton();
        pn_Square_Container = new kuasar.plugin.classMod.Panel_Trans_Square();
        pn_Round_Container = new kuasar.plugin.classMod.Panel_Opaque();
        spn_File = new javax.swing.JScrollPane();
        txa_File = new javax.swing.JTextArea();
        lbl_Password = new javax.swing.JLabel();
        pwd_password = new javax.swing.JPasswordField();
        tb_save = new javax.swing.JToggleButton();
        lbl_error = new javax.swing.JLabel();
        tb_saveKey = new javax.swing.JToggleButton();
        lbl_title = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Password Request");
        setAlwaysOnTop(true);
        setBackground(new java.awt.Color(0, 0, 0));
        setUndecorated(true);

        pn_Buttons.setOpaque(false);

        tgb_top.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/go-down.png"))); // NOI18N
        tgb_top.setSelected(true);
        tgb_top.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tgb_top.setBorderPainted(false);
        tgb_top.setContentAreaFilled(false);
        tgb_top.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/go-top.png"))); // NOI18N
        tgb_top.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tgb_topStateChanged(evt);
            }
        });

        bt_Cancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/exit.png"))); // NOI18N
        bt_Cancel.setBorderPainted(false);
        bt_Cancel.setContentAreaFilled(false);
        bt_Cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_CancelActionPerformed(evt);
            }
        });

        bt_Accept.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/dialog-ok-apply.png"))); // NOI18N
        bt_Accept.setBorderPainted(false);
        bt_Accept.setContentAreaFilled(false);
        bt_Accept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_AcceptActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pn_ButtonsLayout = new javax.swing.GroupLayout(pn_Buttons);
        pn_Buttons.setLayout(pn_ButtonsLayout);
        pn_ButtonsLayout.setHorizontalGroup(
            pn_ButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pn_ButtonsLayout.createSequentialGroup()
                .addContainerGap(387, Short.MAX_VALUE)
                .addComponent(tgb_top)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(bt_Cancel, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bt_Accept, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pn_ButtonsLayout.setVerticalGroup(
            pn_ButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pn_ButtonsLayout.createSequentialGroup()
                .addGroup(pn_ButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(tgb_top, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(bt_Cancel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(bt_Accept, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pn_Square_Container.setBackground(new java.awt.Color(0, 0, 0));
        pn_Square_Container.setOpaque(false);

        pn_Round_Container.setOpaque(false);

        txa_File.setColumns(20);
        txa_File.setEditable(false);
        txa_File.setLineWrap(true);
        txa_File.setRows(3);
        txa_File.setWrapStyleWord(true);
        txa_File.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                txa_FileMouseClicked(evt);
            }
        });
        spn_File.setViewportView(txa_File);

        lbl_Password.setFont(new java.awt.Font("Dialog", 1, 18));
        lbl_Password.setForeground(new java.awt.Color(204, 204, 204));
        lbl_Password.setText("Password:");

        pwd_password.setFont(new java.awt.Font("Dialog", 0, 18)); // NOI18N
        pwd_password.setForeground(new java.awt.Color(0, 0, 0));
        pwd_password.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pwd_password.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                pwd_passwordKeyPressed(evt);
            }
        });

        tb_save.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/document-nosave.png"))); // NOI18N
        tb_save.setSelected(true);
        tb_save.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tb_save.setBorderPainted(false);
        tb_save.setContentAreaFilled(false);
        tb_save.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tb_save.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/document-save.png"))); // NOI18N

        lbl_error.setForeground(new java.awt.Color(204, 0, 51));

        tb_saveKey.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/nosave_key.png"))); // NOI18N
        tb_saveKey.setSelected(true);
        tb_saveKey.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        tb_saveKey.setBorderPainted(false);
        tb_saveKey.setContentAreaFilled(false);
        tb_saveKey.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        tb_saveKey.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/save_key.png"))); // NOI18N

        javax.swing.GroupLayout pn_Round_ContainerLayout = new javax.swing.GroupLayout(pn_Round_Container);
        pn_Round_Container.setLayout(pn_Round_ContainerLayout);
        pn_Round_ContainerLayout.setHorizontalGroup(
            pn_Round_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pn_Round_ContainerLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pn_Round_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pn_Round_ContainerLayout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(lbl_Password)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pwd_password, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE))
                    .addComponent(spn_File, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pn_Round_ContainerLayout.createSequentialGroup()
                        .addComponent(lbl_error, javax.swing.GroupLayout.DEFAULT_SIZE, 349, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(tb_saveKey)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(tb_save)))
                .addContainerGap())
        );
        pn_Round_ContainerLayout.setVerticalGroup(
            pn_Round_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pn_Round_ContainerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(spn_File, javax.swing.GroupLayout.DEFAULT_SIZE, 72, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pn_Round_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pwd_password, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbl_Password, javax.swing.GroupLayout.DEFAULT_SIZE, 44, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pn_Round_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(tb_save)
                    .addComponent(tb_saveKey)
                    .addComponent(lbl_error, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        lbl_title.setFont(new java.awt.Font("Dialog", 1, 20));
        lbl_title.setForeground(new java.awt.Color(204, 204, 204));
        lbl_title.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_title.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/icons/certificate.png"))); // NOI18N
        lbl_title.setText("Insert KeyStore");

        javax.swing.GroupLayout pn_Square_ContainerLayout = new javax.swing.GroupLayout(pn_Square_Container);
        pn_Square_Container.setLayout(pn_Square_ContainerLayout);
        pn_Square_ContainerLayout.setHorizontalGroup(
            pn_Square_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pn_Square_ContainerLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pn_Square_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(pn_Round_Container, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lbl_title, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 459, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        pn_Square_ContainerLayout.setVerticalGroup(
            pn_Square_ContainerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pn_Square_ContainerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lbl_title, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pn_Round_Container, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pn_Square_Container, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(pn_Buttons, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(pn_Square_Container, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pn_Buttons, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bt_CancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_CancelActionPerformed
        keystore=null;
        close();
    }//GEN-LAST:event_bt_CancelActionPerformed

    private void tgb_topStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tgb_topStateChanged
        this.setAlwaysOnTop(tgb_top.isSelected());
    }//GEN-LAST:event_tgb_topStateChanged

    private void txa_FileMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_txa_FileMouseClicked
       lbl_error.setVisible(false);
       txa_File.setText("");
       keystore=null;
       JFileChooser jfc = new JFileChooser();
       jfc.setDialogTitle("Select a keyStore file");
       jfc.setDialogType(JFileChooser.OPEN_DIALOG);
       jfc.setMultiSelectionEnabled(false);
       jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
       int status = jfc.showOpenDialog(this);
       if(status == JFileChooser.CANCEL_OPTION) return;
       if(status == JFileChooser.ERROR_OPTION){
           lbl_error.setText("Error loading the selected file");
           lbl_error.setVisible(true);
           return;
       }
       if(jfc.getSelectedFile()== null)return;
       if(!jfc.getSelectedFile().canRead()){
           lbl_error.setText("File can't be readed! Check permissions.");
           lbl_error.setVisible(true);
           return;
       }
       txa_File.setText(jfc.getSelectedFile().getAbsolutePath());
       keystore=jfc.getSelectedFile().getAbsolutePath();
       
    }//GEN-LAST:event_txa_FileMouseClicked

    private void bt_AcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_AcceptActionPerformed
        accept();
    }//GEN-LAST:event_bt_AcceptActionPerformed

    private void pwd_passwordKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_pwd_passwordKeyPressed
        if(evt.getKeyCode() == KeyEvent.VK_ENTER){
            accept();
        }
    }//GEN-LAST:event_pwd_passwordKeyPressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bt_Accept;
    private javax.swing.JButton bt_Cancel;
    private javax.swing.JLabel lbl_Password;
    private javax.swing.JLabel lbl_error;
    private javax.swing.JLabel lbl_title;
    private javax.swing.JPanel pn_Buttons;
    private javax.swing.JPanel pn_Round_Container;
    private javax.swing.JPanel pn_Square_Container;
    private javax.swing.JPasswordField pwd_password;
    private javax.swing.JScrollPane spn_File;
    private javax.swing.JToggleButton tb_save;
    private javax.swing.JToggleButton tb_saveKey;
    private javax.swing.JToggleButton tgb_top;
    private javax.swing.JTextArea txa_File;
    // End of variables declaration//GEN-END:variables
        
    private void accept(){
        if(tb_save.isSelected())
            saveKeyStore();
        if(tb_saveKey.isSelected())
            savePassword();
        close();
    }
    private void saveKeyStore(){
        Connection.saveKeyStore(keystore, address);
    }
    private void savePassword(){
        Connection.saveKSPassword(pwd_password.getPassword(), address);
    }
    public void setHeader(String title){
        lbl_title.setText(title);
    } 
    public char[] getPassword(){
        if(pwd_password.getPassword().length==0) return null;
        return pwd_password.getPassword();
    }
    public String getKeyStore(){
        return keystore;
    }
    private void close(){
        this.dispose();
    }
    
    public void setData(String keystore, char[] password){
        if(keystore != null){
            this.keystore=keystore;
            txa_File.setText(keystore);
        }
        if(password != null)
            pwd_password.setText(String.valueOf(password));
    }
}
