/*
 * Copyright (C) 2011 Jesus Navalon i Pastor <jnavalon at redhermes dot net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Creating.java
 *
 * Created on 16/09/2011, 22:14:53
 */
package kuasar.plugin.deployer.gui.actions.infopns;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;

/**
 *
 * @author Jesus Navalon i Pastor <jnavalon at redhermes dot net>
 */
public class pn_Creating extends javax.swing.JPanel {
    private int currentFrame = 0;
    private String currentImage = "/kuasar/plugin/deployer/icons/animation/creating/creating";
    private Timer imageCreating = new Timer (50, new ActionListener ()
        {
        @Override
            public void actionPerformed(ActionEvent e)
            {
                currentFrame++;
                javax.swing.ImageIcon icon;
                try{
                    icon = new javax.swing.ImageIcon(getClass().getResource(currentImage + currentFrame + ".png"));
                }catch(NullPointerException ex){
                    currentFrame=1;
                    icon =  new javax.swing.ImageIcon(getClass().getResource(currentImage + currentFrame + ".png"));
                }
                lbl_Image.setIcon(icon);
             }
        }); 
    /** Creates new form Creating */
    public pn_Creating() {
        initComponents();
        imageCreating.start();
    }
    public void setValueGlobal(int value){
        pgb_global.setValue(value);
    }
    public void setValueDisk(int value){
        pgb_disk.setValue(value);
    }
    public void showPBDisk(boolean show){
        pgb_disk.setVisible(show);
    }
    public void stopAnimation(){
        imageCreating.stop();
    }
    
    public void changeCurrentImage(String path){
        imageCreating.stop();
        currentFrame = 0;
        currentImage = path;
        imageCreating.start();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pgb_global = new javax.swing.JProgressBar();
        pgb_disk = new javax.swing.JProgressBar();
        lbl_Image = new javax.swing.JLabel();

        setOpaque(false);

        lbl_Image.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_Image.setIcon(new javax.swing.ImageIcon(getClass().getResource("/kuasar/plugin/deployer/icons/animation/creating/creating1.png"))); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbl_Image, javax.swing.GroupLayout.PREFERRED_SIZE, 482, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(pgb_global, javax.swing.GroupLayout.PREFERRED_SIZE, 482, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(pgb_disk, javax.swing.GroupLayout.PREFERRED_SIZE, 482, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(lbl_Image, javax.swing.GroupLayout.PREFERRED_SIZE, 154, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pgb_disk, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pgb_global, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pgb_disk.setVisible(false);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lbl_Image;
    private javax.swing.JProgressBar pgb_disk;
    private javax.swing.JProgressBar pgb_global;
    // End of variables declaration//GEN-END:variables
}
